Index: bfd/elf32-m32r.c
===================================================================
RCS file: /cvs/src/src/bfd/elf32-m32r.c,v
retrieving revision 1.38
diff -c -r1.38 elf32-m32r.c
*** bfd/elf32-m32r.c	3 Dec 2003 17:38:48 -0000	1.38
--- bfd/elf32-m32r.c	18 Dec 2003 10:04:33 -0000
***************
*** 44,49 ****
--- 44,51 ----
    PARAMS ((bfd *abfd, bfd_reloc_code_real_type code));
  static void m32r_info_to_howto_rel
    PARAMS ((bfd *, arelent *, Elf_Internal_Rela *));
+ static void m32r_info_to_howto
+   PARAMS ((bfd *, arelent *, Elf_Internal_Rela *));
  bfd_boolean _bfd_m32r_elf_section_from_bfd_section
    PARAMS ((bfd *, asection *, int *));
  void _bfd_m32r_elf_symbol_processing
***************
*** 77,86 ****
--- 79,112 ----
    PARAMS ((bfd *, struct bfd_link_info *, asection *,
  	   const Elf_Internal_Rela *));
  
+ static bfd_boolean m32r_elf_adjust_dynamic_symbol
+   PARAMS ((struct bfd_link_info *, struct elf_link_hash_entry *));
+ static bfd_boolean m32r_elf_size_dynamic_sections
+   PARAMS ((bfd *, struct bfd_link_info *));
+ 
  asection * m32r_elf_gc_mark_hook
    PARAMS ((asection *, struct bfd_link_info *, Elf_Internal_Rela *,
  	   struct elf_link_hash_entry *, Elf_Internal_Sym *));
  
+ static bfd_boolean m32r_elf_create_dynamic_sections
+   PARAMS ((bfd *, struct bfd_link_info *));
+ 
+ static bfd_boolean m32r_elf_finish_dynamic_sections
+   PARAMS ((bfd *, struct bfd_link_info *));
+                                                                                 
+ static bfd_boolean m32r_elf_finish_dynamic_symbol
+   PARAMS ((bfd *, struct bfd_link_info *, struct elf_link_hash_entry *,
+            Elf_Internal_Sym *));
+                                                                                 
+ static bfd_boolean allocate_dynrelocs
+   PARAMS ((struct elf_link_hash_entry *, PTR));
+ static bfd_boolean readonly_dynrelocs
+   PARAMS ((struct elf_link_hash_entry *, PTR));
+ static enum elf_reloc_type_class m32r_elf_reloc_type_class
+   PARAMS ((const Elf_Internal_Rela *));
+ static bfd_boolean m32r_elf_fake_sections
+   PARAMS ((bfd *, Elf_Internal_Shdr *, asection *));
+ 
  #define NOP_INSN		0x7000
  #define MAKE_PARALLEL(insn)	((insn) | 0x8000)
  
***************
*** 88,98 ****
     This only saves space in libraries and object files, but perhaps
     relocs will be put in ROM?  All in all though, REL relocs are a pain
     to work with.  */
! #define USE_REL	1
  
  #ifndef USE_REL
  #define USE_REL	0
! #endif
  
  static reloc_howto_type m32r_elf_howto_table[] =
  {
--- 114,168 ----
     This only saves space in libraries and object files, but perhaps
     relocs will be put in ROM?  All in all though, REL relocs are a pain
     to work with.  */
! /* #define USE_REL	1
  
  #ifndef USE_REL
  #define USE_REL	0
! #endif */
! /* Use RELA. But use REL to link old objects for backwords compatibility. */
! 
! /* Functions for the M32R ELF linker.  */
!                                                                                 
! /* The name of the dynamic interpreter.  This is put in the .interp
!    section.  */
!                                                                                 
! #define ELF_DYNAMIC_INTERPRETER "/usr/lib/libc.so.1"
!                                                                                 
! /* The nop opcode we use.  */
!                                                                                 
! #define M32R_NOP 0x7000f000
!                                                                                 
! #define PLT_EMPTY   0x10101010  /* RIE  -> RIE */
!                                                                                 
! /* The size in bytes of an entry in the procedure linkage table.  */
! 
! #define PLT_ENTRY_SIZE 20
! #define PLT_HEADER_SIZE 20
!                                                                                 
! /* The first one entries in a procedure linkage table are reserved,
!    and the initial contents are unimportant (we zero them out).
!    Subsequent entries look like this. */
!                                                                                 
! #define PLT0_ENTRY_WORD0  0xd6c00000    /* seth r6, #high(.got+4)          */
! #define PLT0_ENTRY_WORD1  0x86e60000    /* or3  r6, r6, #low(.got)+4)      */
! #define PLT0_ENTRY_WORD2  0x24e626c6    /* ld   r4, @r6+    -> ld r6, @r6  */
! #define PLT0_ENTRY_WORD3  0x1fc6f000    /* jmp  r6          || pnop        */
! #define PLT0_ENTRY_WORD4  PLT_EMPTY     /* RIE             -> RIE          */
!                                                                                 
! #define PLT0_PIC_ENTRY_WORD0  0xa4cc0004 /* ld   r4, @(4,r12)              */
! #define PLT0_PIC_ENTRY_WORD1  0xa6cc0008 /* ld   r6, @(8,r12)              */
! #define PLT0_PIC_ENTRY_WORD2  0x1fc6f000 /* jmp  r6         || nop         */
! #define PLT0_PIC_ENTRY_WORD3  PLT_EMPTY  /* RIE             -> RIE         */
! #define PLT0_PIC_ENTRY_WORD4  PLT_EMPTY  /* RIE             -> RIE         */
!                                                                                 
! #define PLT_ENTRY_WORD0  0xe6000000 /* ld24 r6, .name_in_GOT                */
! #define PLT_ENTRY_WORD1  0x06acf000 /* add  r6, r12          || nop         */
! #define PLT_ENTRY_WORD0b 0xd6c00000 /* seth r6, #high(.name_in_GOT)         */
! #define PLT_ENTRY_WORD1b 0x86e60000 /* or3  r6, r6, #low(.name_in_GOT)      */
! #define PLT_ENTRY_WORD2  0x26c61fc6 /* ld  r6, @r6           -> jmp r6      */
! #define PLT_ENTRY_WORD3  0xe5000000 /* ld24 r5, $offset                     */
! #define PLT_ENTRY_WORD4  0xff000000 /* bra  .plt0.                          */
! 
  
  static reloc_howto_type m32r_elf_howto_table[] =
  {
***************
*** 302,420 ****
           0,                     /* dst_mask */
           FALSE),                /* pcrel_offset */
  
! };
! 
! /* Handle the R_M32R_10_PCREL reloc.  */
! 
! static bfd_reloc_status_type
! m32r_elf_10_pcrel_reloc (abfd, reloc_entry, symbol, data,
! 			 input_section, output_bfd, error_message)
!      bfd * abfd;
!      arelent * reloc_entry;
!      asymbol * symbol;
!      PTR data;
!      asection * input_section;
!      bfd * output_bfd;
!      char ** error_message ATTRIBUTE_UNUSED;
! {
!   /* This part is from bfd_elf_generic_reloc.  */
!   if (output_bfd != (bfd *) NULL
!       && (symbol->flags & BSF_SECTION_SYM) == 0
!       && (! reloc_entry->howto->partial_inplace
! 	  || reloc_entry->addend == 0))
!     {
!       reloc_entry->address += input_section->output_offset;
!       return bfd_reloc_ok;
!     }
  
!   if (output_bfd != NULL)
!     {
!       /* FIXME: See bfd_perform_relocation.  Is this right?  */
!       return bfd_reloc_continue;
!     }
  
!   return m32r_elf_do_10_pcrel_reloc (abfd, reloc_entry->howto,
! 				     input_section,
! 				     data, reloc_entry->address,
! 				     symbol->section,
! 				     (symbol->value
! 				      + symbol->section->output_section->vma
! 				      + symbol->section->output_offset),
! 				     reloc_entry->addend);
! }
  
! /* Utility to actually perform an R_M32R_10_PCREL reloc.  */
  
! static bfd_reloc_status_type
! m32r_elf_do_10_pcrel_reloc (abfd, howto, input_section, data, offset,
! 			    symbol_section, symbol_value, addend)
!      bfd *abfd;
!      reloc_howto_type *howto;
!      asection *input_section;
!      bfd_byte *data;
!      bfd_vma offset;
!      asection *symbol_section ATTRIBUTE_UNUSED;
!      bfd_vma symbol_value;
!      bfd_vma addend;
! {
!   bfd_signed_vma relocation;
!   unsigned long x;
!   bfd_reloc_status_type status;
  
!   /* Sanity check the address (offset in section).  */
!   if (offset > input_section->_cooked_size)
!     return bfd_reloc_outofrange;
  
!   relocation = symbol_value + addend;
!   /* Make it pc relative.  */
!   relocation -=	(input_section->output_section->vma
! 		 + input_section->output_offset);
!   /* These jumps mask off the lower two bits of the current address
!      before doing pcrel calculations.  */
!   relocation -= (offset & -(bfd_vma) 4);
  
!   if (relocation < -0x200 || relocation > 0x1ff)
!     status = bfd_reloc_overflow;
!   else
!     status = bfd_reloc_ok;
  
!   x = bfd_get_16 (abfd, data + offset);
!   relocation >>= howto->rightshift;
!   relocation <<= howto->bitpos;
!   x = (x & ~howto->dst_mask) | (((x & howto->src_mask) + relocation) & howto->dst_mask);
!   bfd_put_16 (abfd, (bfd_vma) x, data + offset);
  
!   return status;
! }
  
! /* Handle the R_M32R_HI16_[SU]LO relocs.
!    HI16_SLO is for the add3 and load/store with displacement instructions.
!    HI16_ULO is for the or3 instruction.
!    For R_M32R_HI16_SLO, the lower 16 bits are sign extended when added to
!    the high 16 bytes so if the lower 16 bits are negative (bit 15 == 1) then
!    we must add one to the high 16 bytes (which will get subtracted off when
!    the low 16 bits are added).
!    These relocs have to be done in combination with an R_M32R_LO16 reloc
!    because there is a carry from the LO16 to the HI16.  Here we just save
!    the information we need; we do the actual relocation when we see the LO16.
!    This code is copied from the elf32-mips.c.  We also support an arbitrary
!    number of HI16 relocs to be associated with a single LO16 reloc.  The
!    assembler sorts the relocs to ensure each HI16 immediately precedes its
!    LO16.  However if there are multiple copies, the assembler may not find
!    the real LO16 so it picks the first one it finds.  */
  
! struct m32r_hi16
! {
!   struct m32r_hi16 *next;
!   bfd_byte *addr;
!   bfd_vma addend;
! };
  
! /* FIXME: This should not be a static variable.  */
  
! static struct m32r_hi16 *m32r_hi16_list;
  
! static bfd_reloc_status_type
  m32r_elf_hi16_reloc (abfd, reloc_entry, symbol, data,
  		     input_section, output_bfd, error_message)
       bfd *abfd ATTRIBUTE_UNUSED;
--- 372,921 ----
           0,                     /* dst_mask */
           FALSE),                /* pcrel_offset */
  
!   EMPTY_HOWTO (13),
!   EMPTY_HOWTO (14),
!   EMPTY_HOWTO (15),
!   EMPTY_HOWTO (16),
!   EMPTY_HOWTO (17),
!   EMPTY_HOWTO (18),
!   EMPTY_HOWTO (19),
!   EMPTY_HOWTO (20),
!   EMPTY_HOWTO (21),
!   EMPTY_HOWTO (22),
!   EMPTY_HOWTO (23),
!   EMPTY_HOWTO (24),
!   EMPTY_HOWTO (25),
!   EMPTY_HOWTO (26),
!   EMPTY_HOWTO (27),
!   EMPTY_HOWTO (28),
!   EMPTY_HOWTO (29),
!   EMPTY_HOWTO (30),
!   EMPTY_HOWTO (31),
!   EMPTY_HOWTO (32),
  
!   /* A 16 bit absolute relocation.  */
!   HOWTO (R_M32R_16_RELA,	/* type */
! 	 0,			/* rightshift */
! 	 1,			/* size (0 = byte, 1 = short, 2 = long) */
! 	 16,			/* bitsize */
! 	 FALSE,			/* pc_relative */
! 	 0,			/* bitpos */
! 	 complain_overflow_bitfield, /* complain_on_overflow */
! 	 bfd_elf_generic_reloc,	/* special_function */
! 	 "R_M32R_16_RELA",	/* name */
! 	 FALSE,			/* partial_inplace */
! 	 0xffff,		/* src_mask */
! 	 0xffff,		/* dst_mask */
! 	 FALSE),		/* pcrel_offset */
  
!   /* A 32 bit absolute relocation.  */
!   HOWTO (R_M32R_32_RELA,	/* type */
! 	 0,			/* rightshift */
! 	 2,			/* size (0 = byte, 1 = short, 2 = long) */
! 	 32,			/* bitsize */
! 	 FALSE,			/* pc_relative */
! 	 0,			/* bitpos */
! 	 complain_overflow_bitfield, /* complain_on_overflow */
! 	 bfd_elf_generic_reloc,/* special_function */
! 	 "R_M32R_32_RELA",		/* name */
! 	 FALSE,			/* partial_inplace */
! 	 0xffffffff,		/* src_mask */
! 	 0xffffffff,		/* dst_mask */
! 	 FALSE),		/* pcrel_offset */
  
!   /* A 24 bit address.  */
!   HOWTO (R_M32R_24_RELA,	/* type */
! 	 0,			/* rightshift */
! 	 2,			/* size (0 = byte, 1 = short, 2 = long) */
! 	 24,			/* bitsize */
! 	 FALSE,			/* pc_relative */
! 	 0,			/* bitpos */
! 	 complain_overflow_unsigned, /* complain_on_overflow */
! 	 bfd_elf_generic_reloc,/* special_function */
! 	 "R_M32R_24_RELA",	/* name */
! 	 FALSE,			/* partial_inplace */
! 	 0xffffff,		/* src_mask */
! 	 0xffffff,		/* dst_mask */
! 	 FALSE),		/* pcrel_offset */
  
!   HOWTO (R_M32R_10_PCREL_RELA,	/* type */
! 	 2,	                /* rightshift */
! 	 1,	                /* size (0 = byte, 1 = short, 2 = long) */
! 	 10,	                /* bitsize */
! 	 TRUE,	                /* pc_relative */
! 	 0,	                /* bitpos */
! 	 complain_overflow_signed, /* complain_on_overflow */
! 	 m32r_elf_10_pcrel_reloc, /* special_function */
! 	 "R_M32R_10_PCREL_RELA",/* name */
! 	 FALSE,	                /* partial_inplace */
! 	 0xff,		        /* src_mask */
! 	 0xff,   		/* dst_mask */
! 	 TRUE),			/* pcrel_offset */
  
!   /* A relative 18 bit relocation, right shifted by 2.  */
!   HOWTO (R_M32R_18_PCREL_RELA,	/* type */
! 	 2,			/* rightshift */
! 	 2,			/* size (0 = byte, 1 = short, 2 = long) */
! 	 16,			/* bitsize */
! 	 TRUE,			/* pc_relative */
! 	 0,			/* bitpos */
! 	 complain_overflow_signed, /* complain_on_overflow */
! 	 bfd_elf_generic_reloc,	/* special_function */
! 	 "R_M32R_18_PCREL_RELA",/* name */
! 	 FALSE,			/* partial_inplace */
! 	 0xffff,		/* src_mask */
! 	 0xffff,		/* dst_mask */
! 	 TRUE),			/* pcrel_offset */
  
!   /* A relative 26 bit relocation, right shifted by 2.  */
!   HOWTO (R_M32R_26_PCREL_RELA,	/* type */
! 	 2,			/* rightshift */
! 	 2,			/* size (0 = byte, 1 = short, 2 = long) */
! 	 26,			/* bitsize */
! 	 TRUE,			/* pc_relative */
! 	 0,			/* bitpos */
! 	 complain_overflow_signed, /* complain_on_overflow */
! 	 bfd_elf_generic_reloc,	/* special_function */
! 	 "R_M32R_26_PCREL_RELA",/* name */
! 	 FALSE,			/* partial_inplace */
! 	 0xffffff,		/* src_mask */
! 	 0xffffff,		/* dst_mask */
! 	 TRUE),			/* pcrel_offset */
  
!   /* High 16 bits of address when lower 16 is or'd in.  */
!   HOWTO (R_M32R_HI16_ULO_RELA,	/* type */
! 	 16,			/* rightshift */
! 	 2,			/* size (0 = byte, 1 = short, 2 = long) */
! 	 16,			/* bitsize */
! 	 FALSE,			/* pc_relative */
! 	 0,			/* bitpos */
! 	 complain_overflow_dont, /* complain_on_overflow */
! 	 bfd_elf_generic_reloc,	/* special_function */
! 	 "R_M32R_HI16_ULO_RELA",/* name */
! 	 FALSE,			/* partial_inplace */
! 	 0x0000ffff,		/* src_mask */
! 	 0x0000ffff,		/* dst_mask */
! 	 FALSE),		/* pcrel_offset */
  
!   /* High 16 bits of address when lower 16 is added in.  */
!   HOWTO (R_M32R_HI16_SLO_RELA,	/* type */
! 	 16,			/* rightshift */
! 	 2,			/* size (0 = byte, 1 = short, 2 = long) */
! 	 16,			/* bitsize */
! 	 FALSE,			/* pc_relative */
! 	 0,			/* bitpos */
! 	 complain_overflow_dont, /* complain_on_overflow */
! 	 bfd_elf_generic_reloc,	/* special_function */
! 	 "R_M32R_HI16_SLO_RELA",/* name */
! 	 FALSE,			/* partial_inplace */
! 	 0x0000ffff,		/* src_mask */
! 	 0x0000ffff,		/* dst_mask */
! 	 FALSE),		/* pcrel_offset */
  
!   /* Lower 16 bits of address.  */
!   HOWTO (R_M32R_LO16_RELA,		/* type */
! 	 0,			/* rightshift */
! 	 2,			/* size (0 = byte, 1 = short, 2 = long) */
! 	 16,			/* bitsize */
! 	 FALSE,			/* pc_relative */
! 	 0,			/* bitpos */
! 	 complain_overflow_dont, /* complain_on_overflow */
! 	 bfd_elf_generic_reloc,	/* special_function */
! 	 "R_M32R_LO16_RELA",	/* name */
! 	 FALSE,			/* partial_inplace */
! 	 0x0000ffff,		/* src_mask */
! 	 0x0000ffff,		/* dst_mask */
! 	 FALSE),		/* pcrel_offset */
  
!   /* Small data area 16 bits offset.  */
!   HOWTO (R_M32R_SDA16_RELA,	/* type */
! 	 0,			/* rightshift */
! 	 2,			/* size (0 = byte, 1 = short, 2 = long) */
! 	 16,			/* bitsize */
! 	 FALSE,			/* pc_relative */
! 	 0,			/* bitpos */
! 	 complain_overflow_signed, /* complain_on_overflow */
! 	 bfd_elf_generic_reloc,	/* special_function */
! 	 "R_M32R_SDA16_RELA",	/* name */
! 	 TRUE,			/* partial_inplace */  /* FIXME: correct? */
! 	 0x0000ffff,		/* src_mask */
! 	 0x0000ffff,		/* dst_mask */
! 	 FALSE),		/* pcrel_offset */
  
!   /* GNU extension to record C++ vtable hierarchy */
!   HOWTO (R_M32R_RELA_GNU_VTINHERIT, /* type */
!          0,                     /* rightshift */
!          2,                     /* size (0 = byte, 1 = short, 2 = long) */
!          0,                     /* bitsize */
!          FALSE,                 /* pc_relative */
!          0,                     /* bitpos */
!          complain_overflow_dont, /* complain_on_overflow */
!          NULL,                  /* special_function */
!          "R_M32R_RELA_GNU_VTINHERIT", /* name */
!          FALSE,                 /* partial_inplace */
!          0,                     /* src_mask */
!          0,                     /* dst_mask */
!          FALSE),                /* pcrel_offset */
  
!   /* GNU extension to record C++ vtable member usage */
!   HOWTO (R_M32R_RELA_GNU_VTENTRY,     /* type */
!          0,                     /* rightshift */
!          2,                     /* size (0 = byte, 1 = short, 2 = long) */
!          0,                     /* bitsize */
!          FALSE,                 /* pc_relative */
!          0,                     /* bitpos */
!          complain_overflow_dont, /* complain_on_overflow */
!          _bfd_elf_rel_vtable_reloc_fn,  /* special_function */
!          "R_M32R_RELA_GNU_VTENTRY",   /* name */
!          FALSE,                 /* partial_inplace */
!          0,                     /* src_mask */
!          0,                     /* dst_mask */
!          FALSE),                /* pcrel_offset */
  
!   EMPTY_HOWTO (45),
!   EMPTY_HOWTO (46),
!   EMPTY_HOWTO (47),
! 
!   /* Like R_M32R_24, but referring to the GOT table entry for
!      the symbol.  */
!   HOWTO (R_M32R_GOT24,		/* type */
! 	 0,			/* rightshift */
! 	 2,			/* size (0 = byte, 1 = short, 2 = long) */
! 	 24,			/* bitsize */
! 	 FALSE,			/* pc_relative */
! 	 0,			/* bitpos */
! 	 complain_overflow_unsigned, /* complain_on_overflow */
! 	 bfd_elf_generic_reloc, /* special_function */
! 	 "R_M32R_GOT24",	/* name */
! 	 FALSE,			/* partial_inplace */
! 	 0xffffff,		/* src_mask */
! 	 0xffffff,		/* dst_mask */
! 	 FALSE),		/* pcrel_offset */
  
!   /* Like R_M32R_PCREL, but referring to the procedure linkage table
!      entry for the symbol.  */
!   HOWTO (R_M32R_26_PLTREL,	/* type */
! 	 2,			/* rightshift */
! 	 2,			/* size (0 = byte, 1 = short, 2 = long) */
! 	 24,			/* bitsize */
! 	 TRUE,			/* pc_relative */
! 	 0,			/* bitpos */
! 	 complain_overflow_signed, /* complain_on_overflow */
! 	 bfd_elf_generic_reloc,	/* special_function */
! 	 "R_M32R_26_PLTREL",	/* name */
! 	 FALSE,			/* partial_inplace */
! 	 0xffffff,		/* src_mask */
! 	 0xffffff,		/* dst_mask */
! 	 TRUE),			/* pcrel_offset */
! 
!   /* This is used only by the dynamic linker.  The symbol should exist
!      both in the object being run and in some shared library.  The
!      dynamic linker copies the data addressed by the symbol from the
!      shared library into the object, because the object being
!      run has to have the data at some particular address.  */
!   HOWTO (R_M32R_COPY,		/* type */
! 	 0,			/* rightshift */
! 	 2,			/* size (0 = byte, 1 = short, 2 = long) */
! 	 32,			/* bitsize */
! 	 FALSE,			/* pc_relative */
! 	 0,			/* bitpos */
! 	 complain_overflow_bitfield, /* complain_on_overflow */
! 	 bfd_elf_generic_reloc, /* special_function */
! 	 "R_M32R_COPY",		/* name */
! 	 FALSE,			/* partial_inplace */
! 	 0xffffffff,		/* src_mask */
! 	 0xffffffff,		/* dst_mask */
! 	 FALSE),		/* pcrel_offset */
! 
!   /* Like R_M32R_24, but used when setting global offset table
!      entries.  */
!   HOWTO (R_M32R_GLOB_DAT,	/* type */
! 	 0,			/* rightshift */
! 	 2,			/* size (0 = byte, 1 = short, 2 = long) */
! 	 32,			/* bitsize */
! 	 FALSE,			/* pc_relative */
! 	 0,			/* bitpos */
! 	 complain_overflow_bitfield, /* complain_on_overflow */
! 	 bfd_elf_generic_reloc, /* special_function */
! 	 "R_M32R_GLOB_DAT",	/* name */
! 	 FALSE,			/* partial_inplace */
! 	 0xffffffff,		/* src_mask */
! 	 0xffffffff,		/* dst_mask */
! 	 FALSE),		/* pcrel_offset */
! 
!   /* Marks a procedure linkage table entry for a symbol.  */
!   HOWTO (R_M32R_JMP_SLOT,	/* type */
! 	 0,			/* rightshift */
! 	 2,			/* size (0 = byte, 1 = short, 2 = long) */
! 	 32,			/* bitsize */
! 	 FALSE,			/* pc_relative */
! 	 0,			/* bitpos */
! 	 complain_overflow_bitfield, /* complain_on_overflow */
! 	 bfd_elf_generic_reloc, /* special_function */
! 	 "R_M32R_JMP_SLOT",	/* name */
! 	 FALSE,			/* partial_inplace */
! 	 0xffffffff,		/* src_mask */
! 	 0xffffffff,		/* dst_mask */
! 	 FALSE),		/* pcrel_offset */
! 
!   /* Used only by the dynamic linker.  When the object is run, this
!      longword is set to the load address of the object, plus the
!      addend.  */
!   HOWTO (R_M32R_RELATIVE,	/* type */
! 	 0,			/* rightshift */
! 	 2,			/* size (0 = byte, 1 = short, 2 = long) */
! 	 32,			/* bitsize */
! 	 FALSE,			/* pc_relative */
! 	 0,			/* bitpos */
! 	 complain_overflow_bitfield, /* complain_on_overflow */
! 	 bfd_elf_generic_reloc, /* special_function */
! 	 "R_M32R_RELATIVE",		/* name */
! 	 FALSE,			/* partial_inplace */
! 	 0xffffffff,		/* src_mask */
! 	 0xffffffff,		/* dst_mask */
! 	 FALSE),		/* pcrel_offset */
! 
!   HOWTO (R_M32R_GOTOFF,	/* type */
! 	 0,			/* rightshift */
! 	 2,			/* size (0 = byte, 1 = short, 2 = long) */
! 	 32,			/* bitsize */
! 	 FALSE,			/* pc_relative */
! 	 0,			/* bitpos */
! 	 complain_overflow_bitfield, /* complain_on_overflow */
! 	 bfd_elf_generic_reloc, /* special_function */
! 	 "R_M32R_GOTOFF",		/* name */
! 	 FALSE,			/* partial_inplace */
! 	 0xffffffff,		/* src_mask */
! 	 0xffffffff,		/* dst_mask */
! 	 FALSE),		/* pcrel_offset */
! 
!   /* An PC Relative 24-bit relocation used when setting PIC offset
!      table register. */
!   HOWTO (R_M32R_GOTPC24,		/* type */
! 	 0,			/* rightshift */
! 	 2,			/* size (0 = byte, 1 = short, 2 = long) */
! 	 24,			/* bitsize */
! 	 TRUE,			/* pc_relative */
! 	 0,			/* bitpos */
! 	 complain_overflow_unsigned, /* complain_on_overflow */
! 	 bfd_elf_generic_reloc, /* special_function */
! 	 "R_M32R_GOTPC24",	/* name */
! 	 FALSE,			/* partial_inplace */
! 	 0xffffff,		/* src_mask */
! 	 0xffffff,		/* dst_mask */
! 	 TRUE),			/* pcrel_offset */
! 
!   /* Like R_M32R_HI16_ULO, but referring to the GOT table entry for
!      the symbol.  */
!   HOWTO (R_M32R_GOT16_HI_ULO,	/* type */
! 	 16,			/* rightshift */
! 	 2,			/* size (0 = byte, 1 = short, 2 = long) */
! 	 16,			/* bitsize */
! 	 FALSE,			/* pc_relative */
! 	 0,			/* bitpos */
! 	 complain_overflow_dont, /* complain_on_overflow */
! 	 bfd_elf_generic_reloc,	/* special_function */
! 	 "R_M32R_GOT16_HI_ULO",	/* name */
! 	 FALSE,			/* partial_inplace */
! 	 0x0000ffff,		/* src_mask */
! 	 0x0000ffff,		/* dst_mask */
! 	 FALSE),		/* pcrel_offset */
! 
!   /* Like R_M32R_HI16_SLO, but referring to the GOT table entry for
!      the symbol.  */
!   HOWTO (R_M32R_GOT16_HI_SLO,	/* type */
! 	 16,			/* rightshift */
! 	 2,			/* size (0 = byte, 1 = short, 2 = long) */
! 	 16,			/* bitsize */
! 	 FALSE,			/* pc_relative */
! 	 0,			/* bitpos */
! 	 complain_overflow_dont, /* complain_on_overflow */
! 	 bfd_elf_generic_reloc,	/* special_function */
! 	 "R_M32R_GOT16_HI_SLO",	/* name */
! 	 FALSE,			/* partial_inplace */
! 	 0x0000ffff,		/* src_mask */
! 	 0x0000ffff,		/* dst_mask */
! 	 FALSE),		/* pcrel_offset */
! 
!   /* Like R_M32R_LO16, but referring to the GOT table entry for
!      the symbol.  */
!   HOWTO (R_M32R_GOT16_LO,	/* type */
! 	 0,			/* rightshift */
! 	 2,			/* size (0 = byte, 1 = short, 2 = long) */
! 	 16,			/* bitsize */
! 	 FALSE,			/* pc_relative */
! 	 0,			/* bitpos */
! 	 complain_overflow_dont, /* complain_on_overflow */
! 	 bfd_elf_generic_reloc,	/* special_function */
! 	 "R_M32R_GOT16_LO",	/* name */
! 	 FALSE,			/* partial_inplace */
! 	 0x0000ffff,		/* src_mask */
! 	 0x0000ffff,		/* dst_mask */
! 	 FALSE),		/* pcrel_offset */
! 
!   /* An PC Relative relocation used when setting PIC offset table register.
!      Like R_M32R_HI16_ULO, but referring to the GOT table entry for
!      the symbol.  */
!   HOWTO (R_M32R_GOTPC_HI_ULO,	/* type */
! 	 16,			/* rightshift */
! 	 2,			/* size (0 = byte, 1 = short, 2 = long) */
! 	 16,			/* bitsize */
! 	 FALSE,			/* pc_relative */
! 	 0,			/* bitpos */
! 	 complain_overflow_dont, /* complain_on_overflow */
! 	 bfd_elf_generic_reloc,	/* special_function */
! 	 "R_M32R_GOTPC_HI_ULO",	/* name */
! 	 FALSE,			/* partial_inplace */
! 	 0x0000ffff,		/* src_mask */
! 	 0x0000ffff,		/* dst_mask */
! 	 TRUE),			/* pcrel_offset */
! 
!   /* An PC Relative relocation used when setting PIC offset table register.
!      Like R_M32R_HI16_SLO, but referring to the GOT table entry for
!      the symbol.  */
!   HOWTO (R_M32R_GOTPC_HI_SLO,	/* type */
! 	 16,			/* rightshift */
! 	 2,			/* size (0 = byte, 1 = short, 2 = long) */
! 	 16,			/* bitsize */
! 	 FALSE,			/* pc_relative */
! 	 0,			/* bitpos */
! 	 complain_overflow_dont, /* complain_on_overflow */
! 	 bfd_elf_generic_reloc,	/* special_function */
! 	 "R_M32R_GOTPC_HI_SLO",	/* name */
! 	 FALSE,			/* partial_inplace */
! 	 0x0000ffff,		/* src_mask */
! 	 0x0000ffff,		/* dst_mask */
! 	 TRUE),			/* pcrel_offset */
! 
!   /* An PC Relative relocation used when setting PIC offset table register.
!      Like R_M32R_LO16, but referring to the GOT table entry for
!      the symbol.  */
!   HOWTO (R_M32R_GOTPC_LO,	/* type */
! 	 0,			/* rightshift */
! 	 2,			/* size (0 = byte, 1 = short, 2 = long) */
! 	 16,			/* bitsize */
! 	 FALSE,			/* pc_relative */
! 	 0,			/* bitpos */
! 	 complain_overflow_dont, /* complain_on_overflow */
! 	 bfd_elf_generic_reloc,	/* special_function */
! 	 "R_M32R_GOTPC_LO",	/* name */
! 	 FALSE,			/* partial_inplace */
! 	 0x0000ffff,		/* src_mask */
! 	 0x0000ffff,		/* dst_mask */
! 	 TRUE),			/* pcrel_offset */
! };
! 
! /* Handle the R_M32R_10_PCREL reloc.  */
! 
! static bfd_reloc_status_type
! m32r_elf_10_pcrel_reloc (abfd, reloc_entry, symbol, data,
! 			 input_section, output_bfd, error_message)
!      bfd * abfd;
!      arelent * reloc_entry;
!      asymbol * symbol;
!      PTR data;
!      asection * input_section;
!      bfd * output_bfd;
!      char ** error_message ATTRIBUTE_UNUSED;
! {
!   /* This part is from bfd_elf_generic_reloc.  */
!   if (output_bfd != (bfd *) NULL
!       && (symbol->flags & BSF_SECTION_SYM) == 0
!       && (! reloc_entry->howto->partial_inplace
! 	  || reloc_entry->addend == 0))
!     {
!       reloc_entry->address += input_section->output_offset;
!       return bfd_reloc_ok;
!     }
! 
!   if (output_bfd != NULL)
!     {
!       /* FIXME: See bfd_perform_relocation.  Is this right?  */
!       return bfd_reloc_continue;
!     }
! 
!   return m32r_elf_do_10_pcrel_reloc (abfd, reloc_entry->howto,
! 				     input_section,
! 				     data, reloc_entry->address,
! 				     symbol->section,
! 				     (symbol->value
! 				      + symbol->section->output_section->vma
! 				      + symbol->section->output_offset),
! 				     reloc_entry->addend);
! }
! 
! /* Utility to actually perform an R_M32R_10_PCREL reloc.  */
! 
! static bfd_reloc_status_type
! m32r_elf_do_10_pcrel_reloc (abfd, howto, input_section, data, offset,
! 			    symbol_section, symbol_value, addend)
!      bfd *abfd;
!      reloc_howto_type *howto;
!      asection *input_section;
!      bfd_byte *data;
!      bfd_vma offset;
!      asection *symbol_section ATTRIBUTE_UNUSED;
!      bfd_vma symbol_value;
!      bfd_vma addend;
! {
!   bfd_signed_vma relocation;
!   unsigned long x;
!   bfd_reloc_status_type status;
! 
!   /* Sanity check the address (offset in section).  */
!   if (offset > input_section->_cooked_size)
!     return bfd_reloc_outofrange;
! 
!   relocation = symbol_value + addend;
!   /* Make it pc relative.  */
!   relocation -=	(input_section->output_section->vma
! 		 + input_section->output_offset);
!   /* These jumps mask off the lower two bits of the current address
!      before doing pcrel calculations.  */
!   relocation -= (offset & -(bfd_vma) 4);
! 
!   if (relocation < -0x200 || relocation > 0x1ff)
!     status = bfd_reloc_overflow;
!   else
!     status = bfd_reloc_ok;
! 
!   x = bfd_get_16 (abfd, data + offset);
!   relocation >>= howto->rightshift;
!   relocation <<= howto->bitpos;
!   x = (x & ~howto->dst_mask) | (((x & howto->src_mask) + relocation) & howto->dst_mask);
!   bfd_put_16 (abfd, (bfd_vma) x, data + offset);
! 
!   return status;
! }
! 
! /* Handle the R_M32R_HI16_[SU]LO relocs.
!    HI16_SLO is for the add3 and load/store with displacement instructions.
!    HI16_ULO is for the or3 instruction.
!    For R_M32R_HI16_SLO, the lower 16 bits are sign extended when added to
!    the high 16 bytes so if the lower 16 bits are negative (bit 15 == 1) then
!    we must add one to the high 16 bytes (which will get subtracted off when
!    the low 16 bits are added).
!    These relocs have to be done in combination with an R_M32R_LO16 reloc
!    because there is a carry from the LO16 to the HI16.  Here we just save
!    the information we need; we do the actual relocation when we see the LO16.
!    This code is copied from the elf32-mips.c.  We also support an arbitrary
!    number of HI16 relocs to be associated with a single LO16 reloc.  The
!    assembler sorts the relocs to ensure each HI16 immediately precedes its
!    LO16.  However if there are multiple copies, the assembler may not find
!    the real LO16 so it picks the first one it finds.  */
! 
! struct m32r_hi16
! {
!   struct m32r_hi16 *next;
!   bfd_byte *addr;
!   bfd_vma addend;
! };
! 
! /* FIXME: This should not be a static variable.  */
! 
! static struct m32r_hi16 *m32r_hi16_list;
! 
! static bfd_reloc_status_type
  m32r_elf_hi16_reloc (abfd, reloc_entry, symbol, data,
  		     input_section, output_bfd, error_message)
       bfd *abfd ATTRIBUTE_UNUSED;
***************
*** 715,721 ****
    unsigned char elf_reloc_val;
  };
  
! static const struct m32r_reloc_map m32r_reloc_map[] =
  {
    { BFD_RELOC_NONE, R_M32R_NONE },
    { BFD_RELOC_16, R_M32R_16 },
--- 1216,1222 ----
    unsigned char elf_reloc_val;
  };
  
! static const struct m32r_reloc_map m32r_reloc_map_old[] =
  {
    { BFD_RELOC_NONE, R_M32R_NONE },
    { BFD_RELOC_16, R_M32R_16 },
***************
*** 732,737 ****
--- 1233,1270 ----
    { BFD_RELOC_VTABLE_ENTRY, R_M32R_GNU_VTENTRY },
  };
  
+ static const struct m32r_reloc_map m32r_reloc_map[] =
+ {
+   { BFD_RELOC_NONE, R_M32R_NONE },
+   { BFD_RELOC_16, R_M32R_16_RELA },
+   { BFD_RELOC_32, R_M32R_32_RELA },
+   { BFD_RELOC_M32R_24, R_M32R_24_RELA },
+   { BFD_RELOC_M32R_10_PCREL, R_M32R_10_PCREL_RELA },
+   { BFD_RELOC_M32R_18_PCREL, R_M32R_18_PCREL_RELA },
+   { BFD_RELOC_M32R_26_PCREL, R_M32R_26_PCREL_RELA },
+   { BFD_RELOC_M32R_HI16_ULO, R_M32R_HI16_ULO_RELA },
+   { BFD_RELOC_M32R_HI16_SLO, R_M32R_HI16_SLO_RELA },
+   { BFD_RELOC_M32R_LO16, R_M32R_LO16_RELA },
+   { BFD_RELOC_M32R_SDA16, R_M32R_SDA16_RELA },
+   { BFD_RELOC_VTABLE_INHERIT, R_M32R_RELA_GNU_VTINHERIT },
+   { BFD_RELOC_VTABLE_ENTRY, R_M32R_RELA_GNU_VTENTRY },
+                                                                                 
+   { BFD_RELOC_M32R_GOT24, R_M32R_GOT24 },
+   { BFD_RELOC_M32R_26_PLTREL, R_M32R_26_PLTREL },
+   { BFD_RELOC_M32R_COPY, R_M32R_COPY },
+   { BFD_RELOC_M32R_GLOB_DAT, R_M32R_GLOB_DAT },
+   { BFD_RELOC_M32R_JMP_SLOT, R_M32R_JMP_SLOT },
+   { BFD_RELOC_M32R_RELATIVE, R_M32R_RELATIVE },
+   { BFD_RELOC_M32R_GOTOFF, R_M32R_GOTOFF },
+   { BFD_RELOC_M32R_GOTPC24, R_M32R_GOTPC24 },
+   { BFD_RELOC_M32R_GOT16_HI_ULO, R_M32R_GOT16_HI_ULO },
+   { BFD_RELOC_M32R_GOT16_HI_SLO, R_M32R_GOT16_HI_SLO },
+   { BFD_RELOC_M32R_GOT16_LO, R_M32R_GOT16_LO },
+   { BFD_RELOC_M32R_GOTPC_HI_ULO, R_M32R_GOTPC_HI_ULO },
+   { BFD_RELOC_M32R_GOTPC_HI_SLO, R_M32R_GOTPC_HI_SLO },
+   { BFD_RELOC_M32R_GOTPC_LO, R_M32R_GOTPC_LO },
+ };
+ 
  static reloc_howto_type *
  bfd_elf32_bfd_reloc_type_lookup (abfd, code)
       bfd *abfd ATTRIBUTE_UNUSED;
